Subject: bug#13494: output from pdb++ never appears in *gud-FILE* buffer

From: Stefan Kangas <[email-masked]>
Date: Mon, 9 Sep 2019 03:12:06 +0200

Matt McClure <[email-masked]> writes:

> I'm trying to use pdb++ [1] in Emacs 24.2.50.1 (x86_64-apple-darwin,
> NS apple-appkit-1038.36) of 2012-09-27 on bob.porkrind.org.
>
> With pdb++ in my Python virtualenv, I type:
>
>     M-x pdb RET python -mpdb foo.py
>
> The *gud-foo.py* buffer says:
>
>     Current directory is /Users/mlm/tmp/
>
> And it never prints pdb++'s output. I expect to see:
>
>     > /Users/mlm/tmp/foo.py(1)<module>()
>     -> """Demonstrating Emacs, pdb++ incompatibility."""
>     (Pdb++)
>
> I stepped into Emacs's pdb function, and saw that sometimes the output
> from pdb++ appears in the buffer as I step through. Sometimes it
> appears in color. Sometimes the corresponding color escape sequences
> appear literally in the buffer.
>
> I can work around the problem by disabling colorized pdb++ output with
> a ~/.pdbrc.py containing:
>
>     from pdb import DefaultConfig
>
>     class Config(DefaultConfig):
>         highlight = False
>
> Still, this seems like an Emacs bug, that it doesn't reliably read the
> colorized output and display it in the buffer.

I couldn't reproduce this issue on current master.  I get the expected
output in the *gud-pdb* buffer:

    Current directory is /Users/skangas/wip/emacs/lisp/
    [2] > /Users/skangas/wip/emacs/lisp/foo.py(1)<module>()
    -> print "foo"
    (Pdb++)

This is on GNU Emacs 27.0.50 (build 1, x86_64-apple-darwin16.7.0, NS
appkit-1504.83 Version 10.12.6 (Build 16G2128)) of 2019-09-08

Can you still reproduce this on a recent version of Emacs, for example
the latest Emacs version 26.2?

If I don't hear back from you in a couple of weeks, I'll just assume
that this was fixed some time in the six years since your report and
close this bug.

Best regards,
Stefan Kangas